load('Divergence')

reps = 100;
burn = 80;
horz = 48;
L = 2;
kc = 1;
maxtrys = 2;
plot_flag = 1;

T = size(cf,1);
N = size(cf,2);
M = size(nx,2);
Z = size(z,2);

fnames = {}; %Specify factor names
vnames = {}; %Specify variable names
for m = 1:M
    fnames = [fnames; sprintf('Var:%s', num2str(m))];
    for r=1:size(x{1,m},2)
        fnames = [fnames; sprintf('Var:%s Reg:%s', num2str(m),num2str(r))];
    end
end
for i = 1:kc
    fnames = [fnames; sprintf('CF Fac:%s', num2str(i))];
end
for i = 1:Z
    fnames = [fnames; sprintf('Glbl Var:%s', num2str(i))];
end
fnames{1,:} = 'Y Global';
fnames{5,:} = 'R Global';
fnames{9,:} = 'P Global';
r=1;
fnames{1+r,:} = 'Y Amer';
fnames{5+r,:} = 'R Amer';
fnames{9+r,:} = 'P Amer';
r=2;
fnames{1+r,:} = 'Y EU';
fnames{5+r,:} = 'R EU';
fnames{9+r,:} = 'P EU';
r=3;
fnames{1+r,:} = 'Y ASIA';
fnames{5+r,:} = 'R ASIA';
fnames{9+r,:} = 'P ASIA';
fnames{end,:} = 'VIX';
fnames{13,:} = 'CF';
if Z>1
    fnames = {'Y Global';	'Y EU';	'Y ASIA';	'R Global';	'R EU';	'R ASIA';	'P Global';	'P EU';	'P ASIA';	'CF';	'Y Amer';	'R Amer';	'P Amer';	'VIX'};
end
for m=1:M
    for r=1:size(x{1,m},2)
        for i=1:size(x{1,m}{1,r},2)
            vnames = [vnames; sprintf('Var:%s Reg:%s Var:%s', num2str(m),num2str(r),num2str(i))];
        end
    end
end
for j=1:N
    vnames = [vnames; sprintf('CF:%s', num2str(j))];
end
for i=1:Z
	vnames = [vnames; sprintf('Glbl Var:%s', num2str(i))];
end

dim_beta = kc+M+Z; %No of variables in the State Vector
for m=1:M
    dim_beta = dim_beta+size(nx{1,m},2);
end

dim_obs = N+Z; %No of variables in the Observation Equation
XX = zeros(1,M);
for m=1:M
    junk = 0;
    for j=1:size(nx{1,m},2)
        dim_obs = dim_obs+nx{1,m}{1,j};
        junk = junk + nx{1,m}{1,j};
    end
    XX(1,m) = junk;
end

X = []; %Observation Eqn Data Vector
XXX = [];
for m=1:M
    XXX{1,m} = [];
    for j=1:size(x{1,m},2)
    XXX{1,m} = [XXX{1,m} x{1,m}{1,j}(:,:)];
    end
    X = [X XXX{1,m}];
end
X = [X cf z];

fid = 1; %Useful Cell Array to note the locations of variables in the observation vector for factor extraction
for m=1:M
    s_loc = 1; %Data Locations for Global Factors
    f_loc = XX(1,m);
    for i=2:m
        s_loc = s_loc + XX(1,i-1);
        f_loc = f_loc + XX(1,i-1);
    end
    Loc_x{fid,1} = [s_loc:f_loc];     
    fid = fid + 1;
    
    for r = 1:size(nx{1,m},2)
        ss_loc = s_loc; %Data Locations for 1st Level Regional Factors
        ff_loc = s_loc -1 + nx{1,m}{1,r};
        for i=2:r
            ss_loc = ss_loc + nx{1,m}{1,i-1};
            ff_loc = ff_loc + nx{1,m}{1,i-1};
        end
        
        Loc_x{fid,1} = [ss_loc:ff_loc];
        fid = fid + 1;
    end
end
for i=1:kc
    Loc_x{fid,1} = [dim_obs-Z-N+1:dim_obs-Z]; %Data Locations for CF Factor
    fid = fid + 1;
end
Loc_x{fid,1} = [dim_obs-Z+1:dim_obs]; %Data Locations for Obs Factors



%Priors & Initial Conditions
F0 = [zeros(dim_beta,dim_beta*L);eye(dim_beta*(L-1)) zeros(dim_beta*(L-1),dim_beta*(L-1))]; %Starting Valus for using Principle Components (PCs)
Lambda = zeros(dim_obs,dim_beta*L); %Starting Valus using Principle Components (PCs)
Lambda(end-Z+1:end,dim_beta-Z+1:dim_beta) = eye(Z);
c_f = zeros(dim_beta*L,1); %Starting Valus for using Principle Components (PCs)
PCs = zeros(T,dim_beta-Z); %Principle Components
PCs = [PCs z];
X_o=X; %PCs are extracted 1st at the global level, then using the residuals (X_o) at the regional level.

[fac,load] = extract(X_o(:,Loc_x{dim_beta-Z,1}),kc); %Extract Common CF Factor
for n=1:N
    resid(:,n) = cf(:,n)-fac*load(n);
end
beta = load;
X_o(:,Loc_x{dim_beta-Z-kc+1,1}) = resid;
Lambda(Loc_x{dim_beta-Z-kc+1,1},dim_beta-Z-kc+1:dim_beta-Z) = beta;

for i =1:kc
    lags =ones(T,1);
    for l=1:L
        lags = [lags lag(fac(:,i),l)];
    end
    bols = lags\fac(:,i); %Starting Valus for Variance Parameters
    c_f(dim_beta-Z-kc+i,:) = bols(1,:);
    F0(dim_beta-Z-kc+i,[dim_beta-Z-kc+i:dim_beta:dim_beta*L-Z-kc+i])=bols(2:end,:)';
    PCs(:,end-Z-kc+i) = fac(:,i);
end



for m=1:M
    loc = 1+(m-1)*(dim_beta-kc-Z)/M;
    data = X_o(:,Loc_x{loc,1});
    [fac,load] = extract(data,1); %Extract Global Factors
    resid = [];
    beta=[];
    for n=1:size(data,2)
        bols = load(n);
        if n==1
            if bols<=0
                fac = -fac;
                bols = -bols;
            end
        end
        resid(:,n) = data(:,n)-fac*bols;
        beta(n) = bols;
    end
    X_o(:,Loc_x{loc,1}) = resid;
    Lambda(Loc_x{loc,1},loc) = beta';
    lags =ones(T,1);
    for l=1:L
        lags = [lags lag(fac,l)];
    end
    bols = lags\fac; %IC for AR and Variance Parameters
    c_f(loc,:) = bols(1,:);
    F0(loc,[loc:dim_beta:loc+end-dim_beta])=bols(2:end,:)'; 
    PCs(:,loc) = fac;
end



for m=1:M
    for r = 1:size(nx{1,m},2)
        loc = 1+r+(m-1)*(dim_beta-kc-Z)/M;
        data = X_o(:,Loc_x{loc,1});
        [fac,load] = extract(data,1); %Extract Regional Factors
        resid = [];
        beta=[];
        for n=1:size(data,2)
            bols = load(n);
            resid(:,n) = data(:,n)-fac*bols;
            beta(n) = bols;
        end
        X_o(:,Loc_x{loc,1}) = resid;
        Lambda(Loc_x{loc,1},loc) = beta';
        lags =ones(T,1);
        for l=1:L
            lags = [lags lag(fac,l)];
        end
        bols = lags\fac; %IC for AR and Variance Parameters
        c_f(loc,:) = bols(1,:);
        F0(loc,[loc:dim_beta:loc+end-dim_beta])=bols(2:end,:)'; 
        PCs(:,loc) = fac;
    end
end


loc = dim_beta-Z+1;
for i=1:Z
    data = X_o(:,Loc_x{loc,1}(i));
    lags =ones(T,1);
    for l=1:L
        lags = [lags lag(data,l)];
    end
    bols = lags\data; %IC for AR and Variance Parameters
    c_f(dim_beta-Z+i,:) = bols(1,:);
    F0(dim_beta-Z+i,[dim_beta-Z+i:dim_beta:dim_beta*L-Z+i])=bols(2:end,:)';
    PCs(:,end-Z+i) = data;
end

for i=1:dim_obs-Z
        resid = X_o(:,i);
        R(i,i) = (resid'*resid)/(size(X_o(:,i),1)-size(Lambda(i,Lambda(i,:)~=0),2));
end
for i=dim_obs-Z+1:dim_obs
    R(i,i) = 0;
end

F = F0;
beta0 = [zeros(dim_beta*L,1)];
P00 = eye(dim_beta*L);

Lambdaa = Lambda;
sign_r_loc = []; %Normalizations for identification - Upper (kxk): Ik
for i=1:dim_beta
    sign_r_loc = [sign_r_loc min(find(Lambda(:,i)~=0))];
end
for m=1:dim_obs
    if isempty(find(sign_r_loc==m))==0
        Lambda(m,:) = 0;
        Lambda(m,min(find(sign_r_loc==m))) = Lambdaa(m,min(find(sign_r_loc==m)));
        sign_r_loc = [];
        for i=1:dim_beta
            sign_r_loc = [sign_r_loc min(find(Lambda(:,i)~=0))];
        end
    end
end

for i=1:size(sign_r_loc,2) 
        junk = Lambda(find(Lambda(:,i)~=0),i);
        Lambda(find(Lambda(:,i)~=0),i) = Lambda(find(Lambda(:,i)~=0),i)/junk(1);
        PCs(:,i) = junk(1)*PCs(:,i);
end
Lambda0 = Lambda;


% Additional priors for VAR coefficients
lamdap=0.2;% 0.1 %tightness of the prior uses value=max(marginal likelihood)
%taup=lamdap; %tightness of prior on sum of coefficients
taup=0; %tightness of prior on sum of coefficients
epsilonp=10000; %tightness of prior on constant
%epsilonp=1; %tightness of prior on constant
muP=mean(PCs)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:dim_beta
    ytemp=PCs(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    %sigmaP=[sigmaP;1];
    %sigmaP=[sigmaP;std(ytemp)];
    e0=[e0 etemp];
end
sigmaP(1:dim_beta-Z)=ones(dim_beta-Z,1); %PCs scale 1
[optL,optP,optD] = getoptlagprior(PCs,L,lamdap,taup,deltaP,epsilonp,muP,sigmaP);
L=optL;
lamdaP=optP;
tauP=optD;
%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd] = create_dummies(lamdaP,tauP,deltaP,epsilonp,L,muP,sigmaP,dim_beta);


lags=[];
for j=1:L
    lags=[lags lag0(PCs,j) ];
end
lags=[lags ones(rows(PCs),1)];
Y=PCs(L+1:end,:);
lags=lags(L+1:end,:);
Y0=[Y;yd];
X0=[lags;xd];
beta = PCs(2:end,:);
QQ=0.1*eye(dim_beta); %starting value for sigma
Q = [QQ zeros(dim_beta*(L-1),dim_beta*(L-1)); zeros(dim_beta*(L-1),dim_beta*(L))];
F0=vec(X0\Y0);
%Factor Model Country-Specific Components
Lambda=Lambda0;
Lambda0((Lambda0~=0))=0;
R0=0.1*R;
R0(R0~=0)=1; %Factor Model Country-Specific Components
Tr0=3;



%Gibbs sampling algorithm 
beta_store = zeros(T-1,dim_beta,reps-burn);
Lambda_store = zeros(dim_obs,dim_beta,reps-burn);
xfit_store = zeros(dim_obs,T-L+1,reps-burn);
FF_store = zeros(dim_beta,dim_beta*L,reps-burn);
c_store = zeros(dim_beta,reps-burn);
irfs_store = zeros(horz-L,dim_beta,reps-burn,size(shock_no,2));
irfs_x_store = zeros(horz-L,dim_obs,reps-burn,size(shock_no,2));
QQQ_store = zeros(dim_beta,dim_beta,reps-burn);
vardec_store = zeros(horz,dim_beta,dim_beta,reps-burn);
contr_store = zeros(T-1,dim_beta,dim_beta,reps-burn);
contr_init_store = zeros(T-1,dim_beta,reps-burn);
contr_const_store = zeros(T-1,dim_beta,reps-burn);
index=1:20:reps;
tic;
jgibbs=1;
igibbs=1;
while jgibbs<reps-burn
    if sum(igibbs==index)>0
        disp(sprintf('Iteration Number = %s of %s', num2str(igibbs), num2str(reps)));
    end
    
    
    %Step 2: Draw Factor Loadings
    for m=1:dim_obs-Z
        loc = find(Lambda(m,:)~=0);
        yy = X(2:end,m);
        xx = beta(:,loc);
        if m>dim_obs-N
            xx = [xx z(2:end,:)];
        end
        xx = xx(2:end,:);       
        junk=getreg(yy(2:end),xx,Lambda0(m,loc)',R0(loc,loc),R(m,m));
        Lambda(m,loc) = junk(1:size(loc,2));
    end
    
    for i=1:size(sign_r_loc,2)
        Lambda(sign_r_loc(i),i) = 1;
        %junk = Lambda(find(Lambda(:,i)~=0),i);
        %Lambda(find(Lambda(:,i)~=0),i) = Lambda(find(Lambda(:,i)~=0),i)/junk(1);
        %beta(:,i) = beta(:,i)*junk(1);
    end
    
    
    %Step 1: Extract the Factors
    [beta]=carterkohn_gdfmvar(X(2:end,:),c_f,Lambda,F,R,Q,L,Z,beta0,P00);
    if Z>0
        beta(:,dim_beta-Z+1:dim_beta) = z(2:end,:);
    end
    
    %Step 3: Sample FAVAR Coefficients
    Y0=[beta(:,1:dim_beta);yd];
    X0=[];
    for l=1:L
        X0=[X0 lag(beta(:,1:dim_beta),l)];
    end
    X0 = [X0 ones(T-1,1);xd];
    Y0=Y0(L+1:end,:);
    X0=X0(L+1:end,:);
    mstar=vec(X0\Y0);
    xx=X0'*X0;
    ixx=xx\eye(cols(xx));
    
    [FF,PROBLEM] = getcoef(mstar,QQ,ixx,250,dim_beta,L);
    if PROBLEM
        disp('Maxtrys Reached');
        FF=F0;
    else
        F0=FF;
    end
    junk = (reshape(FF,dim_beta*L+1,dim_beta))';
    F(1:dim_beta,1:dim_beta*L) = junk(:,1:end-1);
    c_f(1:dim_beta,1) = junk(:,end);
    
    
    %Step 4: Draw Factor Variance-covariance Matrix
    e=Y0-X0*reshape(FF,dim_beta*L+1,dim_beta);
    scale=e'*e;
    QQ=iwpq(T+rows(yd),inv(scale));
    Q(1:dim_beta,1:dim_beta) = QQ;
    
    %Step 5: Draw Country/Variable Specific Component Variances
    for m=1:dim_obs-Z
        loc = find(Lambda(m,:)~=0);
        error = X(3:end,m)-(Lambda(m,loc)*(beta(2:end,loc))')';
        R(m,m) = IG(Tr0,R0(m,m),error);
    end
    
    
    if igibbs>burn
        jgibbs=jgibbs+1;
        beta_store(:,:,jgibbs) = beta(:,1:dim_beta);
        Lambda_store(:,:,jgibbs) = Lambda(:,1:dim_beta);
        xfit_store(:,:,jgibbs) = Lambda(:,1:dim_beta)*beta(:,1:dim_beta)';
        junk = reshape(FF,dim_beta*L+1,dim_beta);
        FF_store(:,:,jgibbs) = junk(1:end-1,:)';
        c_store(:,jgibbs) = junk(end,:)';
        
        id = ordering;
        QQQ = chol(QQ(id,id))';
        QQQ(id,id) = QQQ;
        
        for s = 1:size(shock_no,2)
            ss = shock_no(s);
            shock = [zeros(1,ss-1) 1 zeros(1,dim_beta-ss)];
            irfs=irfsim(junk,dim_beta,L,QQQ',shock,horz);
            irfs=irfs./repmat(irfs(1,min(find(shock==1))),horz-L,dim_beta);
            irfs_store(:,:,jgibbs,s)=irfs;
            irfs_x_store(:,:,jgibbs,s)=irfs*Lambda(:,1:dim_beta)';
        end
        
        coeffs = junk(1:end-1,:)';
        vardec = var_decp_zm(coeffs,L,QQQ,horz);
        
        VAR.invA = QQQ;
        VAR.Fcomp = [junk(1:end-1,:)'; eye(dim_beta) zeros(dim_beta)];                     % Companion matrix
        VAR.const = 1;                     % constant and/or trends
        VAR.Ft = [junk(end,:)'  junk(1:end-1,:)']';                       % make comparable to notes
        Y0=beta(:,1:dim_beta);
        X0=[ones(T-1,1) lag(beta(:,1:dim_beta),1) lag(beta(:,1:dim_beta),2)];
        Y0=Y0(L+1:end,:);
        X0=X0(L+1:end,:);
        e=Y0-X0*VAR.Ft;
        VAR.residuals = e;
        VAR.nvar = dim_beta;                      % number of endogenous variables
        VAR.nlag = L;           % number of lagged endogenous per equation
        nlag = VAR.nlag;                      % number of lags
        VAR.nvar_ex = 0;                   % number of exogenous (excluding constant and trend)
        VAR.Y = Y0;                         % left-hand side
        VAR.X = X0;

        HD = VARhd(VAR);
        QQQ_store(:,:,jgibbs) = QQQ;
        vardec_store(:,:,:,jgibbs) = vardec;
        contr_store(:,:,:,jgibbs) = HD.shock(:,:,:);
        contr_init_store(:,:,jgibbs) = HD.init(:,:,:);
        contr_const_store(:,:,jgibbs) = HD.const(:,:,:);
    end
    igibbs = igibbs + 1;
end

qus = [.16, .5, .84];
beta_U_Interval = zeros(T-1,dim_beta);
beta_M_Interval = zeros(T-1,dim_beta);
beta_L_Interval = zeros(T-1,dim_beta);
Lambda_U_Interval = zeros(dim_obs,dim_beta);
Lambda_M_Interval = zeros(dim_obs,dim_beta);
Lambda_L_Interval = zeros(dim_obs,dim_beta);
xfit_U_Interval = zeros(dim_obs,T-L+1);
xfit_M_Interval = zeros(dim_obs,T-L+1);
xfit_L_Interval = zeros(dim_obs,T-L+1);
FF_U_Interval = zeros(dim_beta,dim_beta*L);
FF_M_Interval = zeros(dim_beta,dim_beta*L);
FF_L_Interval = zeros(dim_beta,dim_beta*L);
c_U_Interval = zeros(dim_beta,1);
c_M_Interval = zeros(dim_beta,1);
c_L_Interval = zeros(dim_beta,1);
QQQ_U_Interval = zeros(dim_beta,dim_beta);
QQQ_M_Interval = zeros(dim_beta,dim_beta);
QQQ_L_Interval = zeros(dim_beta,dim_beta);
irfs_U_Interval = zeros(horz-L,dim_beta,size(shock_no,2));
irfs_M_Interval = zeros(horz-L,dim_beta,size(shock_no,2));
irfs_L_Interval = zeros(horz-L,dim_beta,size(shock_no,2));
irfs_x_U_Interval = zeros(horz-L,dim_obs,size(shock_no,2));
irfs_x_M_Interval = zeros(horz-L,dim_obs,size(shock_no,2));
irfs_x_L_Interval = zeros(horz-L,dim_obs,size(shock_no,2));
vardec_U_Interval = zeros(horz,dim_beta,dim_beta);
vardec_M_Interval = zeros(horz,dim_beta,dim_beta);
vardec_L_Interval = zeros(horz,dim_beta,dim_beta);
contr_U_Interval = zeros(T-1,dim_beta,dim_beta);
contr_M_Interval = zeros(T-1,dim_beta,dim_beta);
contr_L_Interval = zeros(T-1,dim_beta,dim_beta);
contr_init_U_Interval = zeros(T-1,dim_beta);
contr_init_M_Interval = zeros(T-1,dim_beta);
contr_init_L_Interval = zeros(T-1,dim_beta);
contr_const_U_Interval = zeros(T-1,dim_beta);
contr_const_M_Interval = zeros(T-1,dim_beta);
contr_const_L_Interval = zeros(T-1,dim_beta);
for i = 1:dim_beta
    for tt = 1:T-1
            junk = quantile(beta_store(tt,i,:),qus);
            beta_L_Interval(tt,i) = junk(1);
            beta_M_Interval(tt,i) = junk(2);
            beta_U_Interval(tt,i) = junk(3);
            for j = 1:dim_beta
                junk = quantile(contr_store(tt,i,j,:),qus);
                contr_L_Interval(tt,i,j) = junk(1);
                contr_M_Interval(tt,i,j) = junk(2);
                contr_U_Interval(tt,i,j) = junk(3);
            end
        junk = quantile(contr_init_store(tt,i,:),qus);
        contr_init_L_Interval(tt,i) = junk(1);
        contr_init_M_Interval(tt,i) = junk(2);
        contr_init_U_Interval(tt,i) = junk(3);
        junk = quantile(contr_const_store(tt,i,:),qus);
        contr_const_L_Interval(tt,i) = junk(1);
        contr_const_M_Interval(tt,i) = junk(2);
        contr_const_U_Interval(tt,i) = junk(3);
    end
    for tt = 1:dim_obs
            junk = quantile(Lambda_store(tt,i,:),qus);
            Lambda_L_Interval(tt,i) = junk(1);
            Lambda_M_Interval(tt,i) = junk(2);
            Lambda_U_Interval(tt,i) = junk(3);
    end
    for tt = 1:dim_beta*L
            junk = quantile(FF_store(i,tt,:),qus);
            FF_L_Interval(i,tt) = junk(1);
            FF_M_Interval(i,tt) = junk(2);
            FF_U_Interval(i,tt) = junk(3);
    end
    junk = quantile(c_store(i,:),qus);
    c_L_Interval(i) = junk(1);
    c_M_Interval(i) = junk(2);
    c_U_Interval(i) = junk(3);
    for tt = 1:horz-L
        for s = 1:size(shock_no,2)
            junk = quantile(irfs_store(tt,i,:,s),qus);
            irfs_L_Interval(tt,i,s) = junk(1);
            irfs_M_Interval(tt,i,s) = junk(2);
            irfs_U_Interval(tt,i,s) = junk(3);
        end
    end
    for tt = 1:dim_beta
        junk = quantile(QQQ_store(tt,i,:),qus);
        QQQ_L_Interval(tt,i) = junk(1);
        QQQ_M_Interval(tt,i) = junk(2);
        QQQ_U_Interval(tt,i) = junk(3);
        for h = 1:horz
                junk = quantile(vardec_store(h,tt,i,:),qus);
                vardec_L_Interval(h,tt,i) = junk(1);
                vardec_M_Interval(h,tt,i) = junk(2);
                vardec_U_Interval(h,tt,i) = junk(3);
        end
    end
end
for i = 1:dim_obs
    for tt = 1:T-L+1
            junk = quantile(xfit_store(i,tt,:),qus);
            xfit_L_Interval(i,tt) = junk(1);
            xfit_M_Interval(i,tt) = junk(2);
            xfit_U_Interval(i,tt) = junk(3);
    end
    for tt = 1:horz-L
        for s = 1:size(shock_no,2)
            junk = quantile(irfs_x_store(tt,i,:,s),qus);
            irfs_x_L_Interval(tt,i,s) = junk(1);
            irfs_x_M_Interval(tt,i,s) = junk(2);
            irfs_x_U_Interval(tt,i,s) = junk(3);
        end
    end
end

if plot_flag == 1
    set(0,'DefaultFigureWindowStyle','docked')
    
    figure %Plot Factors
    for i=1:dim_beta
        subplot(4,4,i), plot(yearlab(2:end),beta_M_Interval(:,i),yearlab(2:end),beta_U_Interval(:,i),'-r',yearlab(2:end),beta_L_Interval(:,i),'-r'),axis tight
        title(['Factor Plots: ' fnames{i}])
    end

    %IRFs for Chosen Variables
    sss=[1 9 2 3 6 8 14];
    for ss=1:size(sss,2)
        s=sss(ss);
        figure; 
        for i=1:dim_beta
            subplot(4,4,i),plot(1:horz-L,irfs_M_Interval(:,i,s),1:horz-L,irfs_U_Interval(:,i,s),'-r',1:horz-L,irfs_L_Interval(:,i,s),'-r')
            axis tight, hold on, plot(1:horz-L,zeros(size(1:horz-L)),'-k'), title(['IRFs of ' fnames{i} ' - Shock:' num2str(s)])
        end
    end

    %Stacked FEVDs for CFs
    figure
    i=13;
    rest = 1:dim_beta;
    rest=rest(rest~=i);
    pnames = {'Activity'; 'Interest Rates'; 'Inflation'; 'VIX'};
    for j=1:3
        ss=(j-1)*4+1:(j)*4;
        junk = vardec_M_Interval(:,ss,i);
        subplot(1,3,j),area([junk zeros(size(junk,1),1)]), axis tight, ylim([0 max(max(vardec_M_Interval(:,rest,i)))]), title(['FEVDs - ' pnames{j}]), xlabel('Horizon'), xlabel('% Variance Explained')
        if j==1
            legend('Global','N America','Europe','Asia')
        end 
    end

    %Stacked FEVDs for CFs
    figure
    i=13;
    junk = [];
    for rr = 1:4
        if isempty(find(i==rr-1+[1 5 9]))==1
            junk = [junk sum(vardec_M_Interval(:,rr-1+[1 5 9],i),2)];
        else
            id = id(find(find(i~=id)));
            junk = [junk sum(vardec_M_Interval(:,rr-1+[1 5 9],i),2)];
        end
    end
    junk = [junk vardec_M_Interval(:,14,i)];
    area(junk),axis tight, title(['FEVDs - ' fnames{i}]),legend('Global','N America','Europe','Asia','VIX','Location','south','Orientation','horizontal')

    
    %Stacked HDs for CFs
    i=13;
    figure
    junk = [];
    for j=1:r+1
        idd = [j:r+1:(r+1)*M];
        junk = [junk sum(contr_M_Interval(:,idd(find(i~=idd)),i),2)];
    end
    junk = [contr_M_Interval(:,[i 14],i) junk];
    Xneg = junk; Xneg(Xneg>0) = 0; Xpos = junk; Xpos(Xpos<0) = 0; hold on
    bar(yearlab(2:end),Xneg,'stack'); bar(yearlab(2:end),Xpos,'stack');
    axis tight; h_leg =  legend('Own',fnames{14},'Global','America','Europe','Asia P','location','southeast');
end