function[beta2]=carterkohn_gdfmvar(data,c_f,Lambda,F,R,Q,L,Z,beta0,P00)

Y = data;

T=rows(Y);
N=cols(Y);
%%Step 2a Set up matrices for the Kalman Filter

mu=c_f';
F=F';
x=Lambda;
    
beta11=beta0';
p11=P00;
ns=cols(beta11);
beta_tt=zeros(T,ns);          %will hold the filtered state variable
ptt=zeros(T,ns,ns);    % will hold its variance

% %%%%%%%%%%%Step 2b run Kalman Filter

for i=1:T
    %Prediction
    beta10=mu+beta11*F';
    p10=F*p11*F'+Q;
    yhat=(x*(beta10)')';                                               
    eta=Y(i,:)-yhat;
    feta=(x*p10*x')+R;
    %updating
    K=(p10*x')*invpd(feta);
    beta11=(beta10'+K*eta')';
    p11=p10-K*(x*p10);

    ptt(i,:,:)=p11;
    beta_tt(i,:)=beta11;

end
% beta_tt

%%%%%%%%%%%end of Kalman Filter%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%step 2c Backward recursion to calculate the mean and variance of the distribution of the state
%vector

    
beta2 = zeros(T,ns);   %this will hold the draw of the state variable
jv=[1:ns/L-Z];
wa=randn(T,ns);
f=F(jv,:);
q=Q(jv,jv);
i=T;  %period t
p00=squeeze(ptt(i,jv,jv));
beta2(i,jv)=beta_tt(i:i,jv)+(wa(i:i,jv)*cholx(p00));   %draw for beta in period t from N(beta_tt,ptt)


%periods t-1..to .1

for i=T-1:-1:1
mux=mu(:,jv);
pt=squeeze(ptt(i,:,:));
bm=beta_tt(i:i,:)+(pt*f'*inv(f*pt*f'+q)*(beta2(i+1:i+1,jv)-mux-beta_tt(i,:)*f')')';  
pm=pt-pt*f'*inv(f*pt*f'+q)*f*pt;  
beta2(i:i,jv)=bm(jv)+(wa(i:i,jv)*cholx(pm(jv,jv))); 
end