%% Estimates a MFVAR Model with USA Data using MCMC - Gibbs Sampling Method.

load('usa_data_mfvar'); %Contains Data for USA.

%Note that the data loaded (data_mint & data_m) are monthly. First variable
%is quarterly-GDP, the others are monthly. data_m contains NaNs for the
%first 2 months of each quarter, and then quarterly-GDP observation which
%is the sum of 3 months in that quarter. data_mint simply uses 0s for the
%first 2 months.

%Inputs
horizon=12;%forecast horizon
reps=1000;%total reps
burn=800;%burn in
update=10;%prints every update iter
maxtrys=100; %max tries for stable draw
L=3;   %max number of lags in the VAR
lamdap=0.2;% 0.1 %tightness of the prior uses value=max(marginal likelihood)
taup=10*lamdap; %tightness of prior on sum of coefficients
epsilonp=1/1000; %tightness of prior on constant
fix=1;%1; %if fix is 1 no search over prior and lags is done 
tid=[1 1 0];%1 for log differenced variable, 0 otherwise
freq=[0 1 1]; %1 for monthly variable, 0 for quarterly
datesm=createdatesm(1971,2020,4,12);
dateid='1990M03';
dateid_q='1990Q1';
lastq='2014M03';

forecastf=mfvar(data_mint,data_m,L,lamdap,taup,epsilonp,reps,burn,horizon,update,maxtrys,tid,freq,'1990Q1_usa',datesm,lastq);