function [Z_save]=mfvar(data_mint,data_m,Lbig,lamdaPbig,tauPbig,epsilonP,REPS,BURN,HORZ,Update,maxtrys,tid,freq,dateid,datesm,lastq)
N=cols(data_mint);
Y=packr(data_mint);
HORZ_M = HORZ*3;
% Additional priors for VAR coefficients
muP=mean(Y)';
sigmaP=[];
deltaP=[];
e0=[];
for i=1:N
    ytemp=Y(:,i);
    xtemp=[lag0(ytemp,1) ones(rows(ytemp),1)];
    ytemp=ytemp(2:end,:);
    xtemp=xtemp(2:end,:);
    btemp=xtemp\ytemp;
    etemp=ytemp-xtemp*btemp;
    stemp=etemp'*etemp/rows(ytemp);
    if abs(btemp(1))>1
        btemp(1)=1;
    end
    deltaP=[deltaP;btemp(1)];
    sigmaP=[sigmaP;stemp];
    e0=[e0 etemp];
end

L=Lbig;
lamdaP=lamdaPbig;
tauP=tauPbig;

%dummy data to implement priors see http://ideas.repec.org/p/ecb/ecbwps/20080966.html
[yd,xd] = create_dummies(lamdaP,tauP,deltaP,epsilonP,L,muP,sigmaP,N);


%find optimal prior and lag length
N=cols(Y);
%take lags
X=[];
X_m=[];
for j=1:L
    X=[X lag0(data_mint,j) ];
    X_m=[X_m lag0(data_m,j) ];
end
X=[X ones(rows(X),1)];
X_m=[X_m ones(rows(X_m),1)];
Y=Y(L+1:end,:);
Y_m=data_m(L+1:end,:);
T=rows(Y);
X=X(L+1:end,:);
X_m=X_m(L+1:end,:);
for n=1:N
    if freq(n)==0
        for l=1:L
           X_m(:,1+N*(l-1))=NaN;
        end
    end
end
missing_loc_x = find(isnan(X_m)==1); %missing_loc_x locates variables with missing obs in X matrix at each t.
for n=1:N
    if freq(n)==0
        Y_m(:,n) = NaN;
    end
end
missing_loc_y = find(isnan(Y_m)==1); %missing_loc_y locates variables with missing obs in Y matrix at each t.
missing_t=[]; %missing_t locates variables with missing obs at each t.
for t=1:T+L
    junk =[];
    for n = 1:N
       if freq(n) == 1
           if isnan(data_m(t,n))
               junk = [junk n];
           end
       else
           junk = [junk n];
       end
    end
    missing_t.(['t' num2str(t)]) = junk; %M select all the observed data at each t.
end

fsave=zeros(REPS-BURN,HORZ,N); 
fsave_m=zeros(REPS-BURN,HORZ_M,N); 
Z_save=zeros(REPS-BURN,T,N);
Zf_save=zeros(REPS-BURN,T,N);

%Measurement Equation for Missing Observations in C&K Step: X_t = M_t*D_t*Z_t

Xm = [];
for t=1:T+L
    obsv = [];
    for n = 1:N
        if ~isnan(data_m(t,n))
            obsv = [obsv; data_m(t,n)];
        end
    end
    Xm.(['t' num2str(t)]) = obsv; %Xm collects all the observed data at each t.
end

M = [];
for t=1:T+L
    junk =[];
    for n = 1:N
       if freq(n) == 1
           if ~isnan(data_m(t,n))
               junk = [junk; zeros(1,n-1) 1 zeros(1,N-n+N*(L-1))];
           end
       else
           if ~isnan(data_m(t,n)) && strcmp(datesm(t,end-1:end),'03')+strcmp(datesm(t,end-1:end),'06')...
                   +strcmp(datesm(t,end-1:end),'09')+strcmp(datesm(t,end-1:end),'12')==1
               junk = [junk; zeros(1,n-1) 1 zeros(1,N-n) zeros(1,n-1) 0 zeros(1,N-n) zeros(1,n-1) 0 zeros(1,N-n)];
           end
       end
    end
    M.(['t' num2str(t)]) = junk; %M select all the observed data at each t.
end

% Display empty line (to separate samples in the screen shot)
disp(sprintf(' ')) 

Y0=[Y;yd];
X0=[X;xd];
%conditional mean of the VAR coefficients
mstar=vec(X0\Y0);  %ols on the appended data
xx=X0'*X0;
ixx=xx\eye(cols(xx));  %inv(X0'X0) to be used later in the Gibbs sampling algorithm
sigma=eye(N); %starting value for sigma
beta0=vec(X0\Y0);
Z0=zeros(N*L,1);
P00=[100*eye(N) zeros(N,N*(L-1)); zeros(N*(L-1),N*L)];
%Pre-allocate Matrices
Fc=zeros(N*L,1);
Fz=zeros(N,N*L);
for j=2:L
    Fz = [Fz; zeros(N,N*(j-2)) eye(N) zeros(N,N*(L+1-j))];
end
sigmaa = zeros(N*L,N*L);
igibbs=1;
jgibbs=0;

while jgibbs<REPS-BURN

    % Display progress:
    if mod(igibbs,Update)==0 
        disp(sprintf(' Replication %s of %s. Lag %s Prior Tightness %s date %s', ... 
             num2str(igibbs), num2str(REPS),num2str(L),num2str(lamdaP),dateid) );
    end


    %step 1: Sample VAR coefficients
    [beta2,PROBLEM] = getcoef(mstar,sigma,ixx,maxtrys,N,L );
    if PROBLEM
        beta2=beta0;
    else
        beta0=beta2;
    end


    %step 2: draw covariance
    rbeta2 = reshape(beta2,N*L+1,N);
    e=Y0-X0*rbeta2;
    scale=e'*e;
    sigma=iwpq(T+rows(yd),inv(scale));


    %step 3: Draw the missing observations
    %Transition Equation: Z_t = F_c + F_z*Z_t-1 + e_t, where Z_t = [Y_t;Y_t-1;Y_t-2;..;Y_t-L-1];

    Fc(1:N) = rbeta2(end,:)';
    Fz(1:N,1:N*L) = rbeta2(1:end-1,:)'; %Size of beta2: (N*N*L + N,1), ee=Y0-(Fz*X0')' or ee=Y0'-Fz*X0';
    sigmaa(1:N,1:N)=sigma;
    [Z,Zf]=carterkohnmfvarl44(Xm,M,sigmaa,Fc,Fz,Z0,P00,L,N,T+L,missing_t,datesm,freq);
    junk=[];
    for l=1:L
        junk = [junk Z(L+1-l:end-l,1:N)];
    end

    X(missing_loc_x)=junk(missing_loc_x);

    Z=Z(L+1:end,:); %Discard initial observations
    Zf=Zf(L+1:end,:); %Discard initial observations
    ZZ=Z(:,1:N);
    Y(missing_loc_y)=Z(missing_loc_y); %Rearrange Data with the new draw of missing variables

    Y0=[Y;yd];
    X0=[X;xd];
    %conditional mean of the VAR coefficients
    mstar=vec(X0\Y0);  %ols on the appended data
    xx=X0'*X0;
    ixx=xx\eye(cols(xx));  %inv(X0'X0) to be used later in the Gibbs sampling algorithm


    if igibbs>BURN && ~PROBLEM
        jgibbs=jgibbs+1;
        yhat = get_pathsVAR(N, HORZ_M+1, T, L, Y, beta2,sigma);
        Z_save(jgibbs,:,:)=ZZ;
        Zf_save(jgibbs,:,:)=Zf(:,1:N);
        fsave_m(jgibbs,:,:)=yhat(L+1:end-1,:);
    end
    igibbs=igibbs+1;
end